package com.ruoyi.app.controller.common;

import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.common.annotation.Anonymous;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.TreeSelect;
import com.ruoyi.common.core.domain.entity.SysDictData;
import com.ruoyi.common.utils.ImageUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.common.utils.file.FileUtils;
import com.ruoyi.doubledefense.dto.ContractorDTO;
import com.ruoyi.doubledefense.service.IContractorService;
import com.ruoyi.framework.config.ServerConfig;
import com.ruoyi.system.dto.ContractorUserDTO;
import com.ruoyi.system.service.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.io.IOUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.Base64;
import java.util.List;
import java.util.Map;

/**
 * 通用请求处理
 *
 * @author ruoyi
 */
@Api(tags = "APP工具类")
@RestController
//@RequestMapping("/tempcommon/common")//测试切换验证器
@RequestMapping("/app/common")
public class CommonForAppController {
    private static final Logger log = LoggerFactory.getLogger(CommonForAppController.class);

    private static final String FILE_DELIMETER = ",";

    @Autowired
    private ServerConfig serverConfig;
    @Autowired
    private ISysDictDataService dictDataService;
    @Autowired
    private ISysDeptService iSysDeptService;
    @Autowired
    private ITbSysAreaService iTbSysAreaService;
    @Autowired
    private IContractorService iContractorService;
    @Autowired
    private IContractorUserService iContractorUserService;

    @ApiOperation("获取部门树结构")
    @GetMapping("/getDeptTree")
    public AjaxResult getDeptTree() {
        List<TreeSelect> treeSelects = iSysDeptService.selectDeptTreeListForApp(false);
        return AjaxResult.success(treeSelects);
    }

    @ApiOperation("获取部门树结构,包含部门下的所有用户")
    @GetMapping("/getDeptUserTree")
    public AjaxResult getDeptUserTree() {
        List<TreeSelect> treeSelects = iSysDeptService.selectDeptTreeListForApp(true);
        return AjaxResult.success(treeSelects);
    }

    @ApiOperation("获取区域树结构")
    @GetMapping("/getAreaTree")
    public AjaxResult getAreaTree() {
        return AjaxResult.success(iTbSysAreaService.getAreaTree());
    }

    @ApiOperation("获取承包商列表")
    @GetMapping("/getContractorList")
    public AjaxResult getContractorList() {
        return AjaxResult.success(iContractorService.selectContractorList(new ContractorDTO()));
    }

    @ApiOperation("获取承包商用户列表")
    @GetMapping("/getContractorUserList/{contractorId}")
    public AjaxResult getContractorUserList(@PathVariable Long contractorId) {
        ContractorUserDTO contractorUserDTO = new ContractorUserDTO();
        contractorUserDTO.setContractorId(contractorId);
        return AjaxResult.success(iContractorUserService.selectContractorUserList(contractorUserDTO));
    }

    @ApiOperation("获取字典值信息")
    @GetMapping("/getDict")
    public AjaxResult getDict(String dictKey) {
        if (StringUtils.isEmpty(dictKey)) {
            return AjaxResult.success();
        }
        SysDictData dictData = new SysDictData();
        dictData.setDictType(dictKey);
        return AjaxResult.success(dictDataService.selectDictDataList(dictData));
    }


    @ApiOperation("测试方法忽略")
    @GetMapping("/testGetDict")
    public AjaxResult testGetDict(Map<String, Object> map) {

        System.out.println("请求的JSON = " + map);

        SysDictData dictData = new SysDictData();
        dictData.setDictType("gov_sync");
        return AjaxResult.success(dictDataService.selectDictDataList(dictData));
    }

    /**
     * 通用下载请求
     *
     * @param fileName 文件名称
     * @param delete   是否删除
     */
    @GetMapping("/download")
    public void fileDownload(String fileName, Boolean delete, HttpServletResponse response, HttpServletRequest request) {
        try {
            if (!FileUtils.checkAllowDownload(fileName)) {
                throw new Exception(StringUtils.format("文件名称({})非法，不允许下载。 ", fileName));
            }
            String realFileName = System.currentTimeMillis() + fileName.substring(fileName.indexOf("_") + 1);
            String filePath = RuoYiConfig.getDownloadPath() + fileName;

            response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            FileUtils.setAttachmentResponseHeader(response, realFileName);
            FileUtils.writeBytes(filePath, response.getOutputStream());
            if (delete) {
                FileUtils.deleteFile(filePath);
            }
        } catch (Exception e) {
            log.error("下载文件失败", e);
        }
    }

    /**
     * 通用上传请求（单个）
     */
    @PostMapping("/upload")
    public AjaxResult uploadFile(MultipartFile file) throws Exception {
        try {
            // 上传文件路径
            String filePath = RuoYiConfig.getUploadPath();
            // 上传并返回新文件名称
            String fileName = FileUploadUtils.upload(filePath, file);
            String url = serverConfig.getUrl() + fileName;
            AjaxResult ajax = AjaxResult.success();
            ajax.put("url", url);
            ajax.put("fileName", fileName);
            ajax.put("newFileName", FileUtils.getName(fileName));
            ajax.put("originalFilename", file.getOriginalFilename());
            return ajax;
        } catch (Exception e) {
            return AjaxResult.error(e.getMessage());
        }
    }


    /**
     * 图片url转base64
     *
     * @param url 图片地址 /profile/upload/2023/08/15/1 (2) - 副本_20230815143351A004.jpg
     * @return
     * @throws Exception
     */
    @GetMapping("/convertImageToBase64Str")
    public AjaxResult convertImageToBase64Str(String url) throws Exception {
        try {
            // 本地资源路径
            return AjaxResult.success(ImageUtil.convertImageToBase64Str(url));
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return AjaxResult.error(e.getMessage());
        }
    }

    /**
     * base64转图片并存储
     *
     * @param base64String  base64的字符串
     * @param imageFileName 文件名称带后缀  例如：【aaa.jpg】
     * @return
     * @throws Exception
     */
    @PostMapping("/convertBase64StrToImage")
    public AjaxResult convertBase64StrToImage(String base64String, String imageFileName) throws Exception {
        try {
            // 本地资源路径
            String fileName = ImageUtil.convertBase64StrToImage(base64String, imageFileName);

            String url = serverConfig.getUrl() + fileName;
            AjaxResult ajax = AjaxResult.success();
            ajax.put("url", url);
            ajax.put("fileName", fileName);
            ajax.put("newFileName", FileUtils.getName(fileName));
            return ajax;
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return AjaxResult.error(e.getMessage());
        }
    }

    /**
     * 通用上传请求（多个）
     * 如果是图片支持的格式："bmp", "gif", "jpg", "jpeg", "png",
     */
    @ApiOperation("通用上传请求，如果是图片支持的格式：bmp、gif、jpg、jpeg、png")
    @PostMapping("/uploads")
//    public AjaxResult uploadFiles(List<MultipartFile> files) throws Exception {
    public AjaxResult uploadFiles(MultipartFile file) throws Exception {
        try {
            // 上传文件路径
            String filePath = RuoYiConfig.getUploadPath();
/*

            String tempFileName = file.getName();
            InputStream inputStream = file.getInputStream();
            byte[] data = new byte[1024];
            int len = 0;
            FileOutputStream fileOutputStream = null;
            try {
                File dirFile = new File(filePath);
                fileOutputStream = new FileOutputStream(new File(dirFile, tempFileName));
                while ((len = inputStream.read(data)) != -1) {
                    fileOutputStream.write(data, 0, len);
                }
                fileOutputStream.flush();
            } catch (IOException e) {
                e.printStackTrace();
            } finally {
                if (inputStream != null) {
                    try {
                        inputStream.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
                if (fileOutputStream != null) {
                    try {
                        fileOutputStream.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }

            }
            System.out.println(tempFileName + "写到本地磁盘完成");
*/
            List<String> urls = new ArrayList<>();
            List<String> fileNames = new ArrayList<>();
            List<String> newFileNames = new ArrayList<>();
            List<String> originalFilenames = new ArrayList<>();
//            for (MultipartFile file : files)

            List<MultipartFile> files = new ArrayList<>(1);
            files.add(file);

            for (MultipartFile thisFile : files) {
                // 上传并返回新文件名称
                String fileName = FileUploadUtils.upload(filePath, thisFile);
                String url = serverConfig.getUrl() + fileName;
                urls.add(url);
                fileNames.add(fileName);
                newFileNames.add(FileUtils.getName(fileName));
                originalFilenames.add(thisFile.getOriginalFilename());
            }
            AjaxResult ajax = AjaxResult.success();
            ajax.put("urls", StringUtils.join(urls, FILE_DELIMETER));
            ajax.put("fileNames", StringUtils.join(fileNames, FILE_DELIMETER));
            ajax.put("newFileNames", StringUtils.join(newFileNames, FILE_DELIMETER));
            ajax.put("originalFilenames", StringUtils.join(originalFilenames, FILE_DELIMETER));
            return ajax;
        } catch (Exception e) {
            e.printStackTrace();
            return AjaxResult.error(e.getMessage());
        }
    }

    /**
     * 本地资源通用下载
     */
    @GetMapping("/download/resource")
    public void resourceDownload(String resource, HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        try {
            if (!FileUtils.checkAllowDownload(resource)) {
                throw new Exception(StringUtils.format("资源文件({})非法，不允许下载。 ", resource));
            }
            // 本地资源路径
            String localPath = RuoYiConfig.getProfile();
            // 数据库资源地址
            String downloadPath = localPath + StringUtils.substringAfter(resource, Constants.RESOURCE_PREFIX);
            // 下载名称
            String downloadName = StringUtils.substringAfterLast(downloadPath, "/");
            response.setContentType(MediaType.APPLICATION_OCTET_STREAM_VALUE);
            FileUtils.setAttachmentResponseHeader(response, downloadName);
            FileUtils.writeBytes(downloadPath, response.getOutputStream());
        } catch (Exception e) {
            log.error("下载文件失败", e);
        }
    }
}
